/*
  Modul Contacts for ESP8266
  part of Arduino Mega Server project
*/

#ifdef CONTACTS_FEATURE

#define STATE_NOT_DEFINED 2
#define OPEN  1
#define CLOSE 0

#define CONT_1_OBJECT_NAME "Door1"
#define CONT_2_OBJECT_NAME "Contact2"

#define OPEN_STR "Open"
#define CLOSED_STR "Closed"
#define CONT_2_OPEN_MESS "Down"
#define CONT_2_CLOSE_MESS "Norm"

// states
byte cont1OldState = STATE_NOT_DEFINED; byte cont1ObjState = STATE_NOT_DEFINED;byte cont1State = LOW;
byte cont2OldState = STATE_NOT_DEFINED; byte cont2ObjState = STATE_NOT_DEFINED;byte cont2State = LOW;

void contactsInit() {
  modulContacts = MODUL_ENABLE;
  started("Contacts");
}

void printContactState(char obj[], char mess[]) {
#ifdef EVENTS_CONTACTS
  timeStamp();
  Serial.print(obj);
  Serial.print(": ");
  Serial.println(mess);
#endif
}

void contact1Actions(byte state, char mess[], byte major) {
  cont1ObjState = state;
  printContactState(CONT_1_OBJECT_NAME, mess);
#ifdef MAJORDOMO_FEATURE
  sendRequestM(CONT_1_OBJECT_NAME, major);
#endif
}

void contact2Actions(byte state, char mess[], byte major) {
  cont2ObjState = state;
  printContactState(CONT_2_OBJECT_NAME, mess);
#ifdef MAJORDOMO_FEATURE
  sendRequestM(CONT_2_OBJECT_NAME, major);
#endif
}

void contact1Work() {
  cont1State = I2C2.readByte(0x01, 7);
  if (cont1State != cont1OldState) {
    if (cont1State == LOW) {
      contact1Actions(OPEN,  OPEN_STR,   OPEN);
      lcd.setCursor(8, 0); lcd.print("X");}
    else {
      contact1Actions(CLOSE, CLOSED_STR, CLOSE);
      lcd.setCursor(8, 0); lcd.print("_");}
  cont1OldState = cont1State;
}
}

void contact2Work() {
  cont2State = I2C2.readByte(0x01, 8);
  if (cont2State != cont2OldState) {
    if (cont2State == LOW) {
      contact2Actions(OPEN,  CONT_2_OPEN_MESS,  OPEN);
      lcd.setCursor(9, 0); lcd.print("X");}
    else {contact2Actions(CLOSE, CONT_2_CLOSE_MESS, CLOSE);
          lcd.setCursor(9, 0); lcd.print("_");}
    cont2OldState = cont2State;
  }
}

void contactsWorks() {
  contact1Work();
  contact2Work();
}

#endif // CONTACTS_FEATURE
