/*
  Modul PIR's for ESP8266
  part of Arduino Mega Server project
*/

#ifdef PIRS_FEATURE

#define DETECT_MOTION "Detect motion"
#define END_MOTION "End motion"

#define PIR_1_NAME "PIR1"
#define PIR_2_NAME "PIR2"
#define PIR_3_NAME "PIR3"
#define PIR_4_NAME "PIR4"
#define PIR_5_NAME "PIR5"
#define PIR_6_NAME "PIR6"

// states
byte pir1state = 0; byte pir1 = 0;
byte pir2state = 0; byte pir2 = 0;
byte pir3state = 0; byte pir3 = 0;
byte pir4state = 0; byte pir4 = 0;
byte pir5state = 0; byte pir5 = 0;
byte pir6state = 0; byte pir6 = 0;

// init

void pirsInit() {
  modulPirs = MODUL_ENABLE;
  started("PIR's");
}

#ifdef EVENTS_PIRS
  void pirMess(char s[], char s2[]) {
    timeStamp();
    Serial.print(s);
    Serial.print(' ');
    Serial.println(s2);
  }
#endif

void pir1Actions(byte state, char mess[], byte major) {
  #ifdef EVENTS_PIRS
    pirMess(mess, PIR_1_NAME);
  #endif
  #ifdef MAJORDOMO_FEATURE
    sendRequestM(PIR_1_NAME, major);
  #endif
  #ifdef LEDS_FEATURE
    if (modeLed == LED_PIR) {
      if (state == HIGH) {
        //green(led1, bright);
      } else {
          //black(led1);
        }
    }
  #endif
  pir1state = state;
}

void pir2Actions(byte state, char mess[], byte major) {
  #ifdef EVENTS_PIRS
    pirMess(mess, PIR_2_NAME);
  #endif
  #ifdef MAJORDOMO_FEATURE
    sendRequestM(PIR_2_NAME, major);
  #endif
  #ifdef LEDS_FEATURE
    if (modeLed == LED_PIR) {
      if (state == HIGH) {
        //red(led1, bright);
      } else {
          //black(led1);
        }
    }
  #endif
  pir2state = state;
}

void pir3Actions(byte state, char mess[], byte major) {
  #ifdef EVENTS_PIRS
    pirMess(mess, PIR_3_NAME);
  #endif
  #ifdef MAJORDOMO_FEATURE
    sendRequestM(PIR_3_NAME, major);
  #endif
  #ifdef LEDS_FEATURE
    if (modeLed == LED_PIR) {
      if (state == HIGH) {
        //red(led1, bright);
      } else {
          //black(led1);
        }
    }
  #endif
  pir3state = state;
}
void pir4Actions(byte state, char mess[], byte major) {
  #ifdef EVENTS_PIRS
    pirMess(mess, PIR_4_NAME);
  #endif
  #ifdef MAJORDOMO_FEATURE
    sendRequestM(PIR_4_NAME, major);
  #endif
  #ifdef LEDS_FEATURE
    if (modeLed == LED_PIR) {
      if (state == HIGH) {
        //red(led1, bright);
      } else {
          //black(led1);
        }
    }
  #endif
  pir4state = state;
}
void pir5Actions(byte state, char mess[], byte major) {
  #ifdef EVENTS_PIRS
    pirMess(mess, PIR_5_NAME);
  #endif
  #ifdef MAJORDOMO_FEATURE
    sendRequestM(PIR_5_NAME, major);
  #endif
  #ifdef LEDS_FEATURE
    if (modeLed == LED_PIR) {
      if (state == HIGH) {
        //red(led1, bright);
      } else {
          //black(led1);
        }
    }
  #endif
  pir5state = state;
}
void pir6Actions(byte state, char mess[], byte major) {
  #ifdef EVENTS_PIRS
    pirMess(mess, PIR_6_NAME);
  #endif
  #ifdef MAJORDOMO_FEATURE
    sendRequestM(PIR_6_NAME, major);
  #endif
  #ifdef LEDS_FEATURE
    if (modeLed == LED_PIR) {
      if (state == HIGH) {
        //red(led1, bright);
      } else {
          //black(led1);
        }
    }
  #endif
  pir6state = state;
}

void pir1Work() {
  byte pir1 = I2C2.readByte(0x01,9);
  if (pir1 == 1) {
    if (pir1state == 0)  {pir1Actions(1,   END_MOTION, 1);}
  } else {
    if (pir1state == 1) {pir1Actions(0, DETECT_MOTION, 0);}
  }
}

void pir2Work() {
  byte pir2 = I2C2.readByte(0x01,10);
  if (pir2 == 1) {
    if (pir2state == 0)  {pir2Actions(1,   END_MOTION, 1);}
  } else {
    if (pir2state == 1) {pir2Actions(0, DETECT_MOTION, 0);}
  }
}
void pir3Work() {
  byte pir3 = I2C2.readByte(0x01,11);
  if (pir3 == 1) {
    if (pir3state == 0)  {pir3Actions(1,   END_MOTION, 1);}
  } else {
    if (pir3state == 1) {pir3Actions(0, DETECT_MOTION, 0);}
  }
}
void pir4Work() {
  byte pir4 = I2C2.readByte(0x01,12);
  if (pir4 == 1) {
    if (pir4state == 0)  {pir4Actions(1,   END_MOTION, 1);}
  } else {
    if (pir4state == 1) {pir4Actions(0, DETECT_MOTION, 0);}
  }
}
void pir5Work() {
  byte pir5 = I2C2.readByte(0x01,13);
  if (pir5 == 1) {
    if (pir5state == 0)  {pir5Actions(1,   END_MOTION, 1);}
  } else {
    if (pir5state == 1) {pir5Actions(0, DETECT_MOTION, 0);}
  }
}
void pir6Work() {
  byte pir6 = I2C2.readByte(0x01,14);
  if (pir6 == 1) {
    if (pir6state == 0)  {pir6Actions(1,   END_MOTION, 1);}
  } else {
    if (pir6state == 1) {pir6Actions(0, DETECT_MOTION, 0);}
  }
}

void pirsWorks() 
{
  pir1Work();
  pir2Work();
  pir3Work();
  pir4Work();
  pir5Work();
  pir6Work();
}

#endif // PIRS_FEATURE
